﻿using System;
using System.Configuration;
using System.Data;
using System.IO;
using Chloe;
using Chloe.SqlServer;

using G.MES.ViewModel.File;

namespace Common.Unit.File
{
    public class DownLoad
    {
        public FileDownInfo DownLoadFile(FileDownLoadReq req)
        {
            //先获取web.confgi有没有配置
            var configFile = ConfigurationManager.AppSettings[req.ConfigKey];
            string configFilePath = "";
            if (!string.IsNullOrEmpty(configFile))
            {
                configFilePath = configFile;
            }

            DataTable dt = getFilDataTable(req);
            string path = configFilePath+ (dt.Rows.Count==0  ? "" :dt.Rows[0][req.FilePathField].ToString());
           var f = new FileInfo(path);
            byte[] buffer=null;
            if (f.Exists)
            {
                var stream = new MemoryStream(System.IO.File.ReadAllBytes(path));
                //buffer = stream.GetBuffer();

                buffer = new byte[stream.Capacity];
                if (stream.CanRead)
                {
                    stream.Read(buffer, 0, stream.Capacity);

                }
            }


            FileDownInfo info=new FileDownInfo();
            info.FileName = dt.Rows.Count == 0 ? "" : dt.Rows[0][req.FileNameField].ToString();
            info.bt = buffer;
            return info;

            // return new FileStreamResult(f.OpenRead(), "application/octet-stream", "中文的jun2019.docx");
        }
        //根据表名反射得到表对象
        private DataTable getFilDataTable(FileDownLoadReq req)
        {
           string sqlConn = ConfigurationManager.ConnectionStrings["MainDB"].ToString();    
            using (var context = new MsSqlContext(sqlConn))
            {
                Guid GOID=new Guid(req.OID);
               DataTable dt = context.Session.ExecuteDataTable("SELECT  " + req.FileNameField + "," + req.FilePathField + "   FROM " + req.TableName +
                                                                "   where " + req.TableName + "OID=@OID ", new { OID = GOID });
               return dt;
            }

          
        }



    }
}
