﻿using log4net;
using log4net.Config;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.IO;
using System.Linq;
using System.Text;

namespace Common.Unit
{
    public class Log4
    {
        static Log4()
        {
            XmlConfigurator.Configure(new FileInfo("Log4net.config"));
        }
        private static Log4 _instance = null;
        private static ILog ILog;
        /// <summary>定义Log4的属性，建议用默认的</summary>
        public static Log4 Write(Type t)
        {
            if (_instance == null)
                _instance = new Log4();
            ILog = LogManager.GetLogger(t);
            return _instance;
        }
        /// <summary>定义日志的追踪属性,是记录人的标识，一般都是开发人员自己的英文名字或者简写</summary>
        public static Log4 Write(string logger = "")
        {
            if (_instance == null)
                _instance = new Log4();
            ILog = LogManager.GetLogger(logger);
            return _instance;
        }
        /// <summary>
        /// 写调试信息
        /// </summary>
        /// <param name="msg">消息</param>
        public void Debug(string msg)
        {
            ILog.Debug(msg);
        }

        /// <summary>
        /// 写普通信息
        /// </summary>
        /// <param name="msg">消息</param>
        public void Info(string msg)
        {
            ILog.Info(msg);
        }
        /// <summary>
        /// 写错误信息
        /// </summary>
        /// <param name="msg">消息</param>
        public void Error(string msg)
        {
            ILog.Error(msg);
        }

        /// <summary>
        /// 写错误信息
        /// </summary>
        /// <param name="msg">消息</param>
        /// <param name="ex">错误信息</param>
        public void Error(string msg, Exception ex)
        {
            ILog.Error(msg, ex);
        }
    }
}
