﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;

namespace Common.Unit
{
    public class SqlHelper
    {
        private string sqlconn = ConfigurationManager.ConnectionStrings["MainDB"].ToString();

        /// <summary> 返回执行是否执行成功  增 删 改  都可以用这个</summary>
        public int ExcuteSql(string sqlstr, SqlParameter[] para = null)
        {
            int row = 0;
            using (SqlConnection conn = new SqlConnection(sqlconn))
            {
                SqlCommand comm = new SqlCommand();
                comm.Connection = conn;
                comm.CommandText = sqlstr;
                if (para != null)
                { comm.Parameters.AddRange(para); }
                try
                {
                    conn.Open();
                    row = comm.ExecuteNonQuery();
                    conn.Close();
                    comm.Parameters.Clear();
                }
                catch (Exception ex)
                {
                    conn.Close();
                    throw (ex);
                }
            }
            return row;
        }
        /// <summary>执行reader的读取 </summary>
        public SqlDataReader ExcuteReader(string sqlstr, SqlParameter[] para = null)
        {
            SqlConnection conn = new SqlConnection(sqlconn);
            SqlCommand comm = new SqlCommand();
            comm.Connection = conn;
            comm.CommandText = sqlstr;
            if (para != null)
            { comm.Parameters.AddRange(para); }
            try
            {
                conn.Open();
                SqlDataReader reader = comm.ExecuteReader(System.Data.CommandBehavior.CloseConnection);
                return reader;
            }
            catch (Exception ex)
            {
                conn.Close();
                throw (ex);
            }
        }

        /// <summary>返回Datatabale的查询</summary>
        public DataTable ExcuteDatatable(string sqlstr, SqlParameter[] para = null)
        {
            DataTable dt = new DataTable();
            using (SqlConnection conn = new SqlConnection(sqlconn))
            {
                SqlCommand comm = new SqlCommand();
                comm.Connection = conn;
                comm.CommandText = sqlstr;
                if (para != null) { comm.Parameters.AddRange(para); }
                SqlDataAdapter sa = new SqlDataAdapter();
                sa.SelectCommand = comm;
                try
                {
                    conn.Open();
                    sa.Fill(dt);
                    conn.Close();
                    comm.Parameters.Clear();
                }
                catch (Exception ex)
                {
                    conn.Close();
                    throw (ex);
                }
            }
            return dt;
        }
    }
}
