﻿using G.MES.API.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;

namespace G.MES.API.App_Start
{
    public class ApiErrorHandleAttribute : System.Web.Http.Filters.ExceptionFilterAttribute
    {
        /// <summary>
        /// 程序报错执行的数据处理
        /// </summary>
        /// <param name="actionExecutedContext"></param>
        public override void OnException(System.Web.Http.Filters.HttpActionExecutedContext actionExecutedContext)
        {
            base.OnException(actionExecutedContext);
            var errorMessage = actionExecutedContext.Exception.Message;
            int code = 400;
            var errArry = errorMessage.Split('^');
            if (errArry.Length == 2)
            {
                code = errArry[0] == "0" ? code : Convert.ToInt32(errArry[0]);
                errorMessage = errArry[1];
            }
            else
            {
                //这里记录接口报错日志
            }
            var result = new ApiResult()
            {
                Status = "ERR",
                StatusCode = HttpStatusCode.OK,
                MsgCode = code,
                Msg = errorMessage
            };
            actionExecutedContext.Response = actionExecutedContext.Request.CreateResponse(HttpStatusCode.OK, result);
        }
    }
}