﻿using Microsoft.Security.Application;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Threading;
using System.Threading.Tasks;
using System.Web;
using System.Web.Http.Controllers;

namespace G.MES.API.App_Start
{
    public class XssActionInvoker: ApiControllerActionInvoker
    {
        public override Task<HttpResponseMessage> InvokeActionAsync(HttpActionContext actionContext, CancellationToken cancellationToken)
        {
            //请求头参数处理---未实现


            Dictionary<string, object> changeDictionary = new Dictionary<string, object>();
            //上下文参数处理
            foreach (var para in actionContext.ActionArguments)
            {
                if (para.Value != null)
                {
                    var paraType = para.Value.GetType();
                    //string类型参数，一般为uri上的参数
                    if (paraType == typeof(string))
                    {
                        var value = para.Value.ToString();
                        if (!string.IsNullOrWhiteSpace(value))
                        {
                            value = Sanitizer.GetSafeHtmlFragment(value);//移除有危险的html标签 比如<script>
                                                                         //value = System.Web.HttpUtility.HtmlEncode(value);//将html标签进行编码
                            changeDictionary.Add(para.Key, value);
                        }
                    }
                    else if (paraType.IsClass)
                    {
                        var properties = paraType.GetProperties();
                        bool flag = false;
                        foreach (var e in properties)
                        {
                            if (e.PropertyType == typeof(string))
                            {
                                var value = e.GetValue(para.Value) as string;
                                if (!string.IsNullOrWhiteSpace(value))
                                {
                                    value = Sanitizer.GetSafeHtmlFragment(value);
                                    e.SetValue(para.Value, value);
                                    flag = true;
                                }
                            }
                        }
                        if (flag)
                        {
                            changeDictionary.Add(para.Key, para.Value);
                        }
                    }
                }
                
            }
            foreach (var para in changeDictionary)
            {
                actionContext.ActionArguments[para.Key] = para.Value;
            }
            return base.InvokeActionAsync(actionContext, cancellationToken);
        }
    }
}