﻿using G.Buss.BaseInfo.Services.ChemotherapySVC;
using G.MES.API.App_Start;
using G.MES.DataModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;

namespace G.MES.API.Controllers
{
    /// <summary>
    /// 化疗结果
    /// </summary>
    public class ChemotherapyController : BasicController
    {
        private readonly ChemotherapySvc svc = new ChemotherapySvc();
        /// <summary>
        /// 获取化药结果
        /// </summary>
        [HttpGet]
        [NoAuthAttribute]
        public List<Chemotherapy> GetChemotherapy()
        {
            return svc.GetChemotherapy();
        }

        /// <summary>
        /// 导入化疗结果
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool ImportChemotherapy()
        {
            try
            {
                HttpPostedFile file = HttpContext.Current.Request.Files["Excel"];
                if (file == null)
                {
                    returnWarn("文件不能为空");
                }
                return svc.ImportChemotherapy(file);
            }
            catch (Exception e)
            {
                throw new Exception("表格导入错误" + e.Message);
            }
        }
    }
}