﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using G.Buss.System;
using G.MES.ViewModel;

namespace G.MES.API.Controllers
{
    

    public class CodeController : BasicController
    {
        private readonly CodeSvc codeSvc = new CodeSvc();
        /// <summary>
        /// 获取用户的代码表
        /// </summary>
        /// <param name="CodeTableID"></param>
        /// <returns></returns>
        [HttpGet]
        public List<DropValue>GetUserCodeList(string CodeTableID)
        {
            if (string.IsNullOrEmpty(CodeTableID))
            {
                returnWarn("代码表标记不能为空");
                
            }
            return codeSvc.getCodeList(CodeTableID);
        }
        /// <summary>
        /// 得到系统的代码表
        /// </summary>
        /// <param name="CodeTableID"></param>
        /// <returns></returns>
        [HttpGet]
        public List<DropValue> GetSysCodeList(string CodeTableID)
        {
            if (string.IsNullOrEmpty(CodeTableID))
            {
                returnWarn("代码表标记不能为空");

            }
            return codeSvc.getSysCodeList(CodeTableID);
        }
        /// <summary>
        /// 获取代码表详情
        /// </summary>
        /// <param name="CodeTableID">代码表标记</param>
        /// <param name="key">值</param>
        /// <returns></returns>
        [HttpGet]
        public DropValue getSysCodeInfo(string CodeTableID,string key)
        {
            if (string.IsNullOrEmpty(CodeTableID) || string.IsNullOrEmpty(key))
            {
                returnWarn("代码表或者值不能为空");
            }
            var result = codeSvc.getSysCodeInfo(CodeTableID, key);
            if (result == null)
            {
                returnWarn("找不到详情信息，请检查参数输入");
            }
            return result;
        }
    }
}
