﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;
using G.Buss.BaseInfo.Services.CodeTableSVC;
using G.Buss.BaseInfo.ViewModel.CodeTableModel;
using G.MES.ViewModel;

namespace G.MES.API.Controllers
{
    /// <summary>
    /// 代码表
    /// </summary>
 

    public class CodeTableController : BasicController
    {
        private readonly CodeTableOperaSVC CodeTableSVC = new CodeTableOperaSVC();
        /// <summary>
        /// 获取全部
        /// </summary>
        /// <param name="requestModel"></param>
        /// <returns></returns>
        [HttpPost]
        public List<AllCodeTableResponseModel> GetAllCodeTable(AllCodeTableRequestModel requestModel)
        {
            try
            {
                return CodeTableSVC.DoGetAllCodeTable(requestModel);
            }
            catch (Exception ex)
            {
                throw new Exception("代码表获取：" + ex.Message);
            }
        }
        /// <summary>
        /// 删除代码表
        /// </summary>
        /// <param name="requestModel"></param>
        /// <returns></returns>
        [HttpPost]

        public bool DelCodeTable(DelCodeTableRequestModel requestModel)
        {
            try
            {
                return CodeTableSVC.DoDelCodeTable(requestModel.CodeClassifyOID);
            }
            catch (Exception ex)
            {
                throw new Exception("删除代码表：" + ex.Message);
            }
        }
        /// <summary>
        /// 新增或更新
        /// </summary>
        /// <param name="requestModel"></param>
        /// <returns></returns>
        [HttpPost]

        public bool SaveORUpdateCodeTable(SaveORUpdateCodeTableRequestModel requestModel)
        {
            try
            {

                return CodeTableSVC.DoSaveORUpdateCodeTable(requestModel);
            }
            catch (Exception ex)
            {
                throw new Exception("保存代码表：" + ex.Message);
            }
        }
        /// <summary>
        /// 获取明细列表
        /// </summary>
        /// <returns></returns>
        [HttpPost]

        public PageData GetSonCodeTable(SonCodeTableRequestModel requestModel)
        {

            try
            {
                return CodeTableSVC.DoGetSonCodeTable(requestModel);
            }
            catch (Exception ex)
            {
                throw new Exception("获取明细列表：" + ex.Message);
            }
        }
        /// <summary>
        /// 获取当前代码表下所有代码信息
        /// </summary>
        /// <param name="CodeTableID"></param>
        /// <returns></returns>
        [HttpGet]

        public List<SonCodeTableResponseModel> GetAllSonCodeTable(string CodeTableID)
        {
          
            try
            {
                return CodeTableSVC.DoGetAllSonCodeTable(CodeTableID);
            }
            catch (Exception ex)
            {
                throw new Exception("获取明细列表：" + ex.Message);
            }
        }
        /// <summary>
        /// 新增或更新明细
        /// </summary>
        /// <returns></returns>
        [HttpPost]

        public bool SaveORUpdateSonCodeTable(SaveORUpdateSonCodeTableListRequestModel requestModel)
        {

            try
            {
                return CodeTableSVC.DoSaveORUpdateSonCodeTable(requestModel);
            }
            catch (Exception ex)
            {
                throw new Exception("更新或新增明细列表：" + ex.Message);
            }
        }
        /// <summary>
        /// 批量删除明细
        /// </summary>
        /// <param name="requestModel"></param>
        /// <returns></returns>
        [HttpPost]

        public bool DelSonCodeTable(DelSonCodeTableRequestModel requestModel)
        {

            try
            {
                return CodeTableSVC.DoDelSonCodeTable(requestModel.CodeValueOIDList);
            }
            catch (Exception ex)
            {
                throw new Exception("删除明细：" + ex.Message);
            }
        }

    }
}