﻿using G.Buss.BaseInfo.Services.GeneticRisksSVC;
using G.Buss.BaseInfo.ViewModel.GeneticRisksModel;
using G.MES.ViewModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;

namespace G.MES.API.Controllers
{
    /// <summary>
    /// 遗传风险
    /// </summary>
    public class GeneticRisksController:BasicController
    {
        public readonly GeneticRisksSVC GeneticRisks = new GeneticRisksSVC();
        /// <summary>
        /// 获取遗传风险列表
        /// </summary>
        /// <param name="requestModel"></param>
        /// <returns></returns>
        [HttpPost]
        public PageData GetGeneticRisks(GeneticRisksRequestModel requestModel)
        {
            try
            {
                LoginInfo user = GetLoginUser();
                return GeneticRisks.DoGetGeneticRisks(requestModel, user);
            }
            catch (Exception ex)
            {
                throw new Exception("获取遗传风险表格" + ex.Message);
            }
        }
        /// <summary>
        /// 批量保存（新增或更新）
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool SaveGeneticRisks(List<GeneticRisksSaveRequestModel> requestModel)
        {
            try
            {
                LoginInfo user = GetLoginUser();
                foreach (GeneticRisksSaveRequestModel item in requestModel)
                {
                    GeneticRisks.DoSaveGeneticRisks(item, user);
                }
                return true;
            }
            catch (Exception ex)
            {
                throw new Exception("保存遗传风险表格：" + ex.Message);
            }
        }
        /// <summary>
        /// 批量删除 
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool DelGeneticRisks(List<Guid> requestModel)
        {
            try
            {
                return GeneticRisks.DoDelGeneticRisks(requestModel);
            }
            catch (Exception ex)
            {
                throw new Exception("删除遗传风险表格：" + ex.Message);
            }
        }

        /// <summary>
        /// excel导入
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool ImportGeneticRisks()
        {
            try
            {
                LoginInfo user = GetLoginUser();
                HttpPostedFile file = HttpContext.Current.Request.Files["Excel"];
                return GeneticRisks.DoImportGeneticRisks(file, user);

            }
            catch (Exception ex)
            {
                throw new Exception("导入遗传风险表格：" + ex.Message);
            }

        }
    }
}