﻿using G.Buss.BaseInfo.Services.MISReportSVC;
using G.Buss.BaseInfo.ViewModel.MISReportModel;
using G.MES.ViewModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;

namespace G.MES.API.Controllers
{
    /// <summary>
    /// MIS结果列表
    /// </summary>
    public class MISReportController:BasicController
    {
        public readonly MISReportSVC Correlation = new MISReportSVC();
        /// <summary>
        /// MIS结果列表
        /// </summary>
        /// <param name="requestModel"></param>
        /// <returns></returns>
        [HttpPost]
        public PageData GetMISReport(MISReportRequestModel requestModel)
        {
            try
            {
                LoginInfo user = GetLoginUser();
                return Correlation.DoGetMISReport(requestModel, user);
            }
            catch (Exception ex)
            {
                throw new Exception("获取遗传风险表格" + ex.Message);
            }
        }
        /// <summary>
        /// 批量保存（新增或更新）
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool SaveMISReport(List<MISReportSaveRequestModel> requestModel)
        {
            try
            {
                LoginInfo user = GetLoginUser();
                foreach (MISReportSaveRequestModel item in requestModel)
                {
                    Correlation.DoSaveMISReport(item, user);
                }
                return true;
            }
            catch (Exception ex)
            {
                throw new Exception("保存遗传风险表格：" + ex.Message);
            }
        }
        /// <summary>
        /// 批量删除 
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool DelMISReport(List<Guid> requestModel)
        {
            try
            {
                return Correlation.DoDelMISReport(requestModel);
            }
            catch (Exception ex)
            {
                throw new Exception("删除遗传风险表格：" + ex.Message);
            }
        }
    }
}