﻿using Common.Unit;
using Common.Unit.Redis;
using G.MES.API.App_Start;
using G.MES.ViewModel;
using System;
using System.Collections.Generic;
using System.Drawing.Imaging;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Http;

namespace G.MES.API.Controllers
{
    public class SystemController: BasicController
    {

        /// <summary>
        /// 生成验证码
        /// </summary>
        /// <returns></returns>
        [NoAuthAttribute]
        [HttpGet]
        public VerCode GetVerCode()
        {
            PictureCAPTCHA picture = new PictureCAPTCHA(4, 2);
            var image = picture.Image;
            byte[] data = null;
            var stream = new MemoryStream();
            image.Save(stream, ImageFormat.Jpeg);
            data = stream.ToArray();
            VerCode verCode = new VerCode();
            verCode.ID = Guid.NewGuid();
            RedisHelper redis = new RedisHelper();
            try
            {
                var exist = redis.StringGet<string>(verCode.ID.ToString());
                if (!string.IsNullOrEmpty(exist))
                    redis.ListRemove(verCode.ID.ToString(), exist);
            }
            catch { }
            //HttpContext.Current.Session["UUID"] = picture.Text;
            string Base64 = "data:image/jpeg;base64," + Convert.ToBase64String(data);
            verCode.image = Base64;
            redis.StringSet(verCode.ID.ToString(), picture.Text, TimeSpan.FromMinutes(5));
            return verCode;
        }
    }
}