﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;
using G.Buss.BaseInfo.Services.AuditLogDetailedSVC;
using G.Buss.BaseInfo.Services.SystemLoggingAttribute;
using G.Buss.BaseInfo.ViewModel.AuditLogDetailedModel;
using G.Buss.BaseInfo.ViewModel.SystemLoggingModel;
using G.MES.ViewModel;

namespace G.MES.API.Controllers
{
    /// <summary>
    /// 系统日志
    /// </summary>
    public class SystemLoggingController : BasicController
    {
        private readonly SystenLoggingTableSVC systenLogging = new SystenLoggingTableSVC();
        private readonly AuditLogDetailedOperaSVC operaSVC = new AuditLogDetailedOperaSVC();
        /// <summary>
        /// 系统日志列表
        /// </summary>
        /// <param name="requestModel"></param>
        /// <returns></returns>
        [HttpPost]
        public PageData GetSystemLoggingList(SystemLoggingRequestModel requestModel)
        {
            return systenLogging.GetSystemLoggingList(requestModel);
        }
        /// <summary>
        /// 获取全部分组好的接口日志
        /// </summary>
        /// <param name="requestModel"></param>
        /// <returns></returns>
        [HttpGet]
        public GetAuditLogListResponseModel GetAllAuditLogDetailed(Guid SysytemLoggingOID)
        {
            try
            {
                if (SysytemLoggingOID == null || SysytemLoggingOID == new Guid())
                {
                    throw new Exception("请求参数不能为空");
                }
                return operaSVC.DoGetAllGetAllAuditLogDetailed(SysytemLoggingOID);
            }
            catch (Exception ex)
            {
                throw new Exception("获取全部记录：" + ex.Message);
            }
        }
    }
}