﻿using G.Buss.BaseInfo.Services.TumorsTypeSVC;
using G.Buss.BaseInfo.ViewModel.Tumorss;
using G.MES.ViewModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;

namespace G.MES.API.Controllers
{
    /// <summary>
    /// 肿瘤类型
    /// </summary>
    public class TumorsTypeController:BasicController
    {
        public readonly TumorsTypeSVC Tumors = new TumorsTypeSVC();
        /// <summary>
        /// 获取肿瘤类型列表
        /// </summary>
        /// <param name="requestModel"></param>
        /// <returns></returns>
        [HttpPost]
        public PageData GetTumorsType(TumorsTypeRequestModel requestModel)
        {
            try
            {
                LoginInfo user = GetLoginUser();
                return Tumors.DoGetTumorsType(requestModel, user);
            }
            catch (Exception ex)
            {
                throw new Exception("获取肿瘤类型表格" + ex.Message);
            }
        }
        /// <summary>
        /// 获取所有肿瘤类型
        /// </summary>
        /// <returns></returns>
        [HttpGet]
        public List<TumorsTypeSelectModel> GetAllTumorsType() {
            try
            {
                LoginInfo user = GetLoginUser();
                return Tumors.DoGetAllTumorsType(user);
            }
            catch (Exception ex)
            {
                throw new Exception("获取肿瘤类型选项" + ex.Message);
            }
        }
        /// <summary>
        /// 批量保存（新增或更新）
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool SaveTumorsType(List<TumorsTypeSaveRequestModel> requestModel)
        {
            try
            {
                LoginInfo user = GetLoginUser();
                foreach (TumorsTypeSaveRequestModel item in requestModel)
                {
                    Tumors.DoSaveTumorsType(item, user);
                }
                return true;
            }
            catch (Exception ex)
            {
                throw new Exception("保存肿瘤类型表格：" + ex.Message);
            }
        }

        /// <summary>
        /// 批量删除 
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool DelTumorsType(List<Guid> requestModel)
        {
            try
            {
                return Tumors.DoDelTumorsType(requestModel);
            }
            catch (Exception ex)
            {
                throw new Exception("删除肿瘤类型表格：" + ex.Message);
            }
        }

        /// <summary>
        /// excel导入
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool ImportTumorsType()
        {
            try
            {
                LoginInfo user = GetLoginUser();
                HttpPostedFile file = HttpContext.Current.Request.Files["Excel"];
                return Tumors.DoImportTumorsType(file, user);

            }
            catch (Exception ex)
            {
                throw new Exception("导入肿瘤类型表格：" + ex.Message);
            }

        }
    }
}