﻿## 刘军修改
### 一、新建化疗结果表
> 字段：药物方案、基因、检测位点、基因型、用药提示、级别
```
CREATE TABLE [dbo].[Chemotherapy](
	[ChemotherapyOID] [UNIQUEIDENTIFIER] NOT NULL,
	[DrugPlan] [VARCHAR](50) NULL,
	[Gene] [VARCHAR](50) NULL,
	[TestSite] [VARCHAR](50) NULL,
	[Genotype] [VARCHAR](50) NULL,
	[MedicationPrompts] [TEXT] NULL,
	[Levels] [VARCHAR](50) NULL,
	[CurrentIndex] [INT] NULL,
	[Sys_Create] [DATETIME] NULL,
	[ParentOID] [UNIQUEIDENTIFIER] NULL,
	[SampleNumber] [INT] NULL,
 CONSTRAINT [PK_Chemotherapy] PRIMARY KEY CLUSTERED 
(
	[ChemotherapyOID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
```
- 新增：ChemotherapyController
### 二、修改GeneCorrelation表Type字段类型
> 2019年12月24日14点10分
```
alter table GeneCorrelation alter column [Type] varchar(50)
```
### 创建检查结果汇总表（Summary）表
```
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

SET ANSI_PADDING ON
GO

CREATE TABLE [dbo].[Summary](
	[SummaryOID] [UNIQUEIDENTIFIER] NOT NULL,
	[Gene] [VARCHAR](50) NULL,
	[Position] [VARCHAR](50) NULL,
	[Annotation] [TEXT] NULL,
	[Abundance] [VARCHAR](50) NULL,
	[Mutations] [VARCHAR](50) NULL,
	[ParentOID] [UNIQUEIDENTIFIER] NOT NULL,
	[SampleNumber] [VARCHAR](50) NULL,
	[Sys_CreateBy] [UNIQUEIDENTIFIER] NULL,
	[Sys_Create] [DATETIME] NULL,
 CONSTRAINT [PK_Summary] PRIMARY KEY CLUSTERED 
(
	[SummaryOID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

GO

SET ANSI_PADDING OFF
GO

EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'基因' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Summary', @level2type=N'COLUMN',@level2name=N'Gene'
GO

EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'突变位置及类型' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Summary', @level2type=N'COLUMN',@level2name=N'Position'
GO

EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'结果注释' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Summary', @level2type=N'COLUMN',@level2name=N'Annotation'
GO

EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'丰度' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Summary', @level2type=N'COLUMN',@level2name=N'Abundance'
GO

EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'突变说明' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Summary', @level2type=N'COLUMN',@level2name=N'Mutations'
GO

EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'样本编号' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Summary', @level2type=N'COLUMN',@level2name=N'SampleNumber'
GO
```
