﻿using Chloe.SqlServer;
using G.Buss.BaseInfo.ViewModel.TargetedMedicineReferencesModel;
using G.MES.DataModel;
using G.MES.ViewModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace G.Buss.BaseInfo.Services.TargetedMedicineReferencesSVC
{
    public class TargetedMedicineReferencesSVC:BaseSvc
    {
        public string DoGetTargetedMedicineReferencesTxt(LoginInfo user)
        {
            using (var context = new MsSqlContext(sqlConn))
            {
                try
                {
                    string TargetedMedicineReferencesTxt = context.Query<TargetedMedicineReferences>().Where(a => a.SYS_CreatedBy == user.Sys_UserOID)
                        .Select(a => a.TargetedMedicineReferencesTxt).FirstOrDefault();
                    if (TargetedMedicineReferencesTxt == null)
                    {
                        TargetedMedicineReferencesTxt = "";
                    }
                    return TargetedMedicineReferencesTxt;
                }
                catch (Exception ex)
                {
                    throw new Exception(ex.Message);
                }
            }
        }
        public bool DoSaveTargetedMedicineReferencesTxt(TargetedMedicineReferencesRequestModel requestModel, LoginInfo user)
        {
            using (var context = new MsSqlContext(sqlConn))
            {
                try
                {
                    TargetedMedicineReferences TargetedMedicineReferences = context.Query<TargetedMedicineReferences>().Where(a => a.SYS_CreatedBy == user.Sys_UserOID)
                        .FirstOrDefault();
                    if (TargetedMedicineReferences == null)//新增
                    {
                        TargetedMedicineReferences = new TargetedMedicineReferences();
                        TargetedMedicineReferences.TargetedMedicineReferencesOID = Guid.NewGuid();
                        TargetedMedicineReferences.TargetedMedicineReferencesTxt = requestModel.TargetedMedicineReferencesTxt;
                        InsertSysField(TargetedMedicineReferences, user);
                        context.Insert(TargetedMedicineReferences);
                    }
                    else//更新
                    {
                        context.TrackEntity(TargetedMedicineReferences);
                        TargetedMedicineReferences.TargetedMedicineReferencesTxt = requestModel.TargetedMedicineReferencesTxt;
                        UpSysField(TargetedMedicineReferences, user);
                        context.Update(TargetedMedicineReferences);
                    }
                    return true;
                }
                catch (Exception ex)
                {
                    throw new Exception(ex.Message);
                }
            }
        }
    }
}
