﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Common.Unit;
using G.MES.DataModel;
using G.MES.ViewModel;
using G.Buss.BaseInfo.ViewModel.ChooseModel;

namespace G.Buss.System
{
  public  class CodeSvc:BaseSvc
    {
        /// <summary>
        /// 获取用户自定义的代码表
        /// </summary>
        /// <param name="CodeTableID"></param>
        /// <returns></returns>
        public List<DropValue> getCodeList(string CodeTableID)
        {
            var find = context.Query<Initi06>().Where(t => t.CodeTableID == CodeTableID).LeftJoin<Initi07>((codem, codez) => codem.Initi06OID == codez.Initi06_FK).
                   Select((codem, codez) => new DropValue
                   {
                       Key = codez.CodeID,
                       Value = codez.CodeName
                   }).ToList();
            return find;
        }
        /// <summary>
        /// 获取系统自定义的代码表
        /// </summary>
        /// <param name="CodeTableID"></param>
        /// <returns></returns>
        public List<DropValue> getSysCodeList(string CodeTableID)
        {
            //var findParent = context.Query<CodeClassify>().Where(t => t.CodeTableID == CodeTableID).LeftJoin<CodeValue>((codem, codez) => codem.CodeClassifyOID == codez.CodeClassifyOID && codez.ParentOID==Guid.Empty).
            //       Select((codem, codez) => new DropValue
            //       {

            //           Key = codez.CodeID,
            //           Value = codez.CodeName
            //       }).ToList();
            var finAll = context.Query<CodeClassify>().Where(t => t.CodeTableID == CodeTableID).LeftJoin<CodeValue>((codem, codez) => codem.CodeClassifyOID == codez.CodeClassifyOID ).
                  Select((codem, codez) => new  SysCodeQuery
                  {

                      Key = codez.CodeID,
                      Value = codez.CodeName,
                      OID=codez.CodeValueOID,
                      Reserved1=codez.Reserved1,
                      ParentOID =codez.ParentOID.Value
                  }).ToList();
            List<DropValue> resultList = new List<DropValue>();
            var findParent = finAll.Where(t => t.ParentOID == Guid.Empty);
            foreach (var item in findParent)
            {
                DropValue one = new DropValue();
                one.Key = item.Key;
                one.Value = item.Value;
                one.Reserved1 = item.Reserved1;

                one.children = BuildTreeSysCode(item.OID, finAll);
                resultList.Add(one);
            }
            return resultList;
        }
        /// <summary>
        /// 获取代码表详情
        /// </summary>
        /// <param name="CodeTableID"></param>
        /// <returns></returns>
        public DropValue getSysCodeInfo(string CodeTableID,string key)
        {
            //var findParent = context.Query<CodeClassify>().Where(t => t.CodeTableID == CodeTableID).LeftJoin<CodeValue>((codem, codez) => codem.CodeClassifyOID == codez.CodeClassifyOID && codez.ParentOID==Guid.Empty).
            //       Select((codem, codez) => new DropValue
            //       {

            //           Key = codez.CodeID,
            //           Value = codez.CodeName
            //       }).ToList();
            var finAll = context.Query<CodeClassify>().Where(t => t.CodeTableID == CodeTableID).LeftJoin<CodeValue>((codem, codez) => codem.CodeClassifyOID == codez.CodeClassifyOID && codez.CodeID == key).
                  Select((codem, codez) => new DropValue
                  {

                      Key = codez.CodeID,
                      Value = codez.CodeName,
                      
                      Reserved1 = codez.Reserved1
                     
                  }).FirstOrDefault();
          
            return finAll;
        }
        /// <summary>
        /// 系统代码表树形递归
        /// </summary>
        /// <param name="ParentOID"></param>
        /// <param name="AllList"></param>
        /// <returns></returns>
        public List<DropValue> BuildTreeSysCode(Guid ParentOID, List<SysCodeQuery> AllList)
        {
            var findList = AllList.Where(t => t.ParentOID == ParentOID);
            List<DropValue> newList = new List<DropValue>();
            foreach (var item in findList)
            {
                DropValue one = new DropValue();
                one.Key = item.Key;
                one.Value = item.Value;
                one.Reserved1 = item.Reserved1;

                one.children = BuildTreeSysCode(item.OID, AllList);
                newList.Add(one);

            }
            return newList;
        } 
    }
}
