﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Chloe;
using Common.Unit;
using G.MES.DataModel;
using G.MES.ViewModel;
namespace G.Buss.System
{
   public class CommonSvc:BaseSvc
    {

        /// <summary>
        /// 返回组织机构树
        /// </summary>
        /// <returns></returns>
        public List<ViewModel.StandardTreeInfo> GetOrgTree(LoginInfo loginInfo,string Name)
        {
            if (string.IsNullOrEmpty(Name))
            {
                return FindOrg(loginInfo);
            }
            else {
                return FindOrg(loginInfo,Name);
            }
        }
        public List<ViewModel.StandardTreeInfo> FindOrg(LoginInfo loginInfo,string Name)
        {
            var where = new LamadaExtention<Sys_Organize>();
            Guid? UserOID = loginInfo.Sys_UserOID;
            //不是管理需要做限制
            where.And(t => t.ORG_FLG == 1);
            if (UserOID != new Guid("00000000-0000-0000-0000-000000000001"))
            {

                where.And(t => t.ClassCode.StartsWith(loginInfo.OrgClassCode));

            }
            else
            {
                where.And(t => 1 == 1);
            }

            var find_chilall = context.Query<Sys_Organize>().Where(where.GetLambda()).ToList();
            var gourbygs = find_chilall.GroupBy(a => a.Sys_OrganizeOID).Select(x => (Guid?)x.Key).ToList();
            //找出有多个这个名称b部门
            var find_bm = context.Query<Sys_Organize>().Where(t => gourbygs.Contains(t.Sys_OrganizeOID) && t.OrgName.Contains(Name)).ToList();


            //找祖先的部门

            Dictionary<Guid, string> dic = new Dictionary<Guid, string>();
            //先递归，再向上找
            foreach (var item in find_bm)
            {
                var findresult = context.SqlQuery<ViewModel.GET_ORGTreeInfo>("SELECT OrgOID,LEVEL_NUM,T1.PARENTOID,T2.OrgName FROM dbo.FN_GET_ORG(@org,1) T1 LEFT OUTER JOIN  dbo.Sys_Organize T2  ON T1.OrgOID = T2.Sys_OrganizeOID",
                    new DbParam("@org", item.Sys_OrganizeOID)).Where(t => gourbygs.Contains(t.OrgOID)).OrderByDescending(t => t.LEVEL_NUM).FirstOrDefault();

                if (!dic.ContainsKey(findresult.OrgOID))
                {
                    // if (find_only_bm.Where(t => t.Sys_DivisionOID == findresult.OrgOID).Count() == 0) continue;

                    dic.Add(findresult.OrgOID, findresult.OrgName);

                }
            }
            List<ViewModel.StandardTreeInfo> list_tree = new List<ViewModel.StandardTreeInfo>();
            foreach (var item in dic)
            {
                //ViewModel.PostTreeInfo v_tree = new ViewModel.PostTreeInfo();

                //int org_flg = find_chilall.Where(t => t.Sys_OrganizeOID == item.Key).FirstOrDefault().ORG_FLG;
                //v_tree.OID = item.Key;
                //v_tree.NAME = item.Value;
                //v_tree.ISBM = true;
                //v_tree.icon = org_flg == 1 ? ViewModel.icon.systemicon.orgicon : ViewModel.icon.systemicon.bmicon;

                //v_tree.children = BuilTree(find_chilall, item.Key, find_post);
                //list_TreeInfos.Add(v_tree);
                var findone = find_chilall.Where(t => t.Sys_OrganizeOID == item.Key).FirstOrDefault();
                int ORG_FLG = findone.ORG_FLG;

                ViewModel.StandardTreeInfo v_tree = new ViewModel.StandardTreeInfo();
                v_tree.OID = item.Key;
                v_tree.ParentOID = findone.ParentOID;
                v_tree.Leves = 1;
                v_tree.Name = item.Value;
                v_tree.icon = ORG_FLG == 1 ? ViewModel.icon.systemicon.orgicon : ViewModel.icon.systemicon.bmicon;
                v_tree.children = BuilTreeOrg(find_chilall, item.Key, 1);
                list_tree.Add(v_tree);
            }
            return list_tree;
        }
        public List<ViewModel.StandardTreeInfo> FindOrg(LoginInfo loginInfo)
        {
            Guid guid2 = Guid.Empty;//默认管理员的是空的
            Guid? UserOID = loginInfo.Sys_UserOID;
            var where = new LamadaExtention<Sys_Organize>();
            //不是管理需要做限制
            if (UserOID != new Guid("00000000-0000-0000-0000-000000000001"))
            {

                where.And(t => t.Sys_OrganizeOID == loginInfo.Sys_OrganizeOID);

            }
            else
            {
                where.And(t => t.ParentOID == Guid.Empty);
            }

            var list_all = context.Query<Sys_Organize>().Where(t => t.ACTIVE_FLAG == true);
            List<ViewModel.StandardTreeInfo> list_tree = new List<ViewModel.StandardTreeInfo>();
            int leves = 1;
            //得出所有根节点的数据
            var find_paren = list_all.Where(where.GetLambda()).ToList().OrderBy(t => t.SortNo);
            foreach (var item in find_paren)
            {
                ViewModel.StandardTreeInfo v_tree = new ViewModel.StandardTreeInfo();
                v_tree.OID = item.Sys_OrganizeOID;
                v_tree.ParentOID = item.ParentOID;
                v_tree.Leves = 1;
                v_tree.Name = item.OrgName;
                v_tree.icon = item.ORG_FLG == 1 ? ViewModel.icon.systemicon.orgicon : ViewModel.icon.systemicon.bmicon;
                v_tree.children = BuilTreeOrg(list_all.ToList(), item.Sys_OrganizeOID, leves);
                list_tree.Add(v_tree);
            }
            return list_tree;
        }

        public List<ViewModel.StandardTreeInfo> BuilTreeOrg(List<Sys_Organize> list_tree2, Guid parentOID,int leves)
        {
            List<ViewModel.StandardTreeInfo> list_view_zree = new List<ViewModel.StandardTreeInfo>();
            var findlist = list_tree2.Where(t => t.ParentOID == parentOID ).OrderBy(t => t.SortNo).ToList();
            leves++;
            foreach (var item in findlist)
            {
                ViewModel.StandardTreeInfo v_tree = new ViewModel.StandardTreeInfo();
                v_tree.OID = item.Sys_OrganizeOID;
                v_tree.ParentOID = item.ParentOID;
                v_tree.Leves = leves;
                v_tree.icon = item.ORG_FLG == 1 ? ViewModel.icon.systemicon.orgicon : ViewModel.icon.systemicon.bmicon;
                v_tree.Name = item.OrgName;

                v_tree.children = BuilTreeOrg(list_tree2, item.Sys_OrganizeOID, leves);
                list_view_zree.Add(v_tree);
            }
            return list_view_zree;
        }


    }
}
