﻿using G.MES.DataModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using G.MES.ViewModel;
using Chloe;
using Chloe.SqlServer;

//using G.MES.DataModel.UserLogin;

namespace G.Buss.System
{
    /// <summary>
    /// 登录服务
    /// </summary>
    public class LoginSvc : BaseSvc
    {
        /// <summary>
        /// 查询一个用户
        /// </summary>
        /// <param name="uid">uid</param>
        /// <returns></returns>
        //public UCML_User GetUserInfo(string uid)
        //{
        //    var one = context.Query<UCML_User>().Where(t => t.USR_LOGIN == uid).FirstOrDefault();
        //    return one;
        //}
        /// <summary>
        /// 登录
        /// </summary>
        /// <param name="token"></param>
        /// <returns></returns>
        public PageReturnInfo UserLogin(string uid, string pwd)
        {
            using (var context = new MsSqlContext(sqlConn))
            {
                PageReturnInfo pageReturnInfo = new PageReturnInfo();
                if (context.Query<Sys_User>().Where(t => t.USR_LOGIN.ToLower() == uid.ToLower()).Count() == 0)
                {
                    pageReturnInfo.flag = false;
                    pageReturnInfo.messages = "用户名不存在";
                    return pageReturnInfo;
                }
                var queryone = context.Query<Sys_User>().Where(t => t.USR_LOGIN.ToLower() == uid.ToLower()).FirstOrDefault();
                if (queryone.PassWord != pwd)
                {
                    pageReturnInfo.flag = false;
                    pageReturnInfo.messages = "密码错误";
                    return pageReturnInfo;
                }
                if (queryone.IsLogin == false)
                {
                    pageReturnInfo.flag = false;
                    pageReturnInfo.messages = "账号已禁用，不允许登录系统";
                    return pageReturnInfo;
                }

                var query = context.JoinQuery<Sys_User, Sys_CONTACT, Sys_Organize, Sys_Organize, Sys_Post>((user, contact, bm, gs, post) => new object[]
                     {
                JoinType.LeftJoin, user.Sys_UserOID == contact.Sys_UserOID,          /* 表 User 和 City 进行Left连接 */
                JoinType.LeftJoin, contact.Sys_DivisionOID == bm.Sys_OrganizeOID,   /* 表 City 和 Province 进行Left连接 */
                JoinType.LeftJoin,  contact.Sys_OrganizeOID==gs.Sys_OrganizeOID,
                JoinType.LeftJoin,  contact.Sys_PostOID==post.Sys_PostOID
                     })
                   .Select((user, contact, bm, gs, post) => new LoginInfo
                   {
                       Sys_UserOID = user.Sys_UserOID,
                       USR_LOGIN = user.USR_LOGIN,
                       PassWord = user.PassWord,
                       Mobile = contact.MobilePhone,
                       EmployeeName = user.EmployeeName,
                       PostName = post.PostName == null ? "" : post.PostName,
                       DivisionName = bm.OrgName == null ? "" : bm.OrgName,
                       OrgName = gs.OrgName == null ? "" : gs.OrgName,
                       photossz = contact.Photo,
                       Sys_PostOID = contact.Sys_PostOID == null ? Guid.Empty : contact.Sys_PostOID,
                       Sys_DivisionOID = contact.Sys_DivisionOID == null ? Guid.Empty : contact.Sys_DivisionOID,
                       Sys_OrganizeOID = contact.Sys_OrganizeOID == null ? Guid.Empty : contact.Sys_OrganizeOID,
                       OrgClassCode = gs.ClassCode == null ? "" : gs.ClassCode


                   }).Where(t => t.USR_LOGIN.ToLower() == uid.ToLower()).FirstOrDefault();
                if (query.photossz != null) query.Photo = "data:image/jpeg;base64," + Convert.ToBase64String(query.photossz);
                pageReturnInfo.flag = true;
                pageReturnInfo.messages = "登录成功";
                pageReturnInfo.data = query;
                return pageReturnInfo;
            }
        }

        /// <summary>
        /// 得到用户分页
        /// </summary>
        /// <param name="index">当前页</param>
        /// <param name="size">每页的数量</param>
        /// <param name="type">查询条件</param>
        /// <returns></returns>
        //public PageData GetUserPager(int index, int size, int type)
        //{
        //    var query = context.Query<UCML_User>();
        //    int totalcount = query.Where(t => t.UserType == type).Count();
        //    var pagedata = query.Where(t => t.UserType == type).TakePage(index, size).OrderBy(t => t.USR_LOGIN).ToList();
        //    PageData data = PageData.Make(index, size, totalcount, pagedata);
        //    return data;
        //}



    }
}
